local balls={}
 balls.effect = love.graphics.newPixelEffect[[
// dashxdr was here 20120228
// adapted to Love by Ref 2013-05-29

extern number time;
extern vec2 mouse;
extern vec2 screen;
#define PI 3.1415927
#define PI2 (PI*2.0)
#define IBALLRAD (1.0/.5)

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec2	position	= ( 2.0*pc.xy - screen) / screen.xx;
	number	adjust1		= 200*mouse.x/screen.x;// * 100.0;

	position	*= adjust1;
	number r	= length(position);
	number fix	= -time*1.3;
	number	a	= atan(position.y, position.x) + PI;
	number	d	= r - a + PI2;
	int		n	= int(d/PI2);
		d		= d - number(n)*PI2;
	number dd	= (d < PI*2.9) ? 0.1 : 0.0;
	number da	= a+number(n)*PI2;
	vec3 norm;
	number pos	= da * da * 0.07 + fix;
	norm.xy		= vec2( fract( pos ) - .5, d / PI2 - .5) * IBALLRAD;
	number len	= length( norm.xy );
	vec3 clor	= vec3( 0.0, 0.0, 0.0 );
	if( len <= 1.0 )
		{
		norm.z 			= sqrt( 1.0 -  len * len );
		vec3 lightdir 	= normalize( vec3( -0.0, -1.0, 1.0 ) );
		dd				= dot( lightdir, norm );
		dd				= max( dd, 0.1 );
		number rand		= sin( floor( pos ) );
		clor.rgb		= dd * fract( rand * vec3( 10.0, 1000.0, 100000.0 ) );
		vec3 halfv		= normalize( lightdir + vec3( 0.0, 0.0, 1.0 ) );
		number spec 	= dot( halfv, norm );
		spec			= max( spec, 0.0 );
		spec			= pow( spec, 40.0 );
		clor			+= spec*vec3( 3.0, 1.0, 1.0 );
		}
	return vec4( clor, 1.0 );
	}
]]

return balls
